
assert(LibStub, "LibKoko-1.0 requires LibStub")

local lib, oldminor = LibStub:NewLibrary("LibKoko-1.0", 1)
if not lib then return end
oldminor = oldminor or 0

local addon_list = {}

function lib:CopyTable(tbl)
	if not tbl then return {} end
   
	local copy = {}
	for k, v in pairs(tbl) do
		if (type(v) == "table") then
			copy[k] = CopyTable(v)
		else
			copy[k] = v
		end
	end
	return copy
end

function lib:RegisterAddon(addon, optMenu)
   -- avoid duplicate addon keys
   if not (addon and optMenu) then return false end
   if addon_list[addon] then print('Attempting to register addon with duplicate key') return false end
   
   addon_list[addon] = optMenu
end

function lib:RegisterAddonPlugIn(addon, plugin, optMenu)
   -- avoid duplicate addon keys
   if not (addon and plugin and optMenu) then return false end
   if addon_list[addon] then 
      if addon_list[addon].args[plugin] then 
         print('Attempting to register addon with duplicate key') return false
      else
         addon_list[addon].args[plugin] = optMenu
      end
   end
end

function lib:AddonListing()
   local set = {}
   for i,_ in pairs(addon_list) do
      tinsert(set,i)
   end
   return set
end